package org.spagic3.attachments;
import org.spagic3.attachments.db.DBAttachmentStore;
import org.spagic3.attachments.fs.FileSystemAttachmentStore;
import org.spagic3.constants.SpagicConstants;


public class AttachmentStoreManager {
	
	
	
	
	public  static IAttachmentStore getAttachmentStore (){
		return getIdentifiedAttachmentStore(getAttachmentStoreId());
	}
	
	private static String getAttachmentStoreId(){		
		String configured = System.getProperty(SpagicConstants.ATTACHMENT_STORE_TYPE);
		
		if (configured == null){
			configured = SpagicConstants.ATTACHMENT_STORE_FYLESYSTEM;
		}
		
		return configured;
	}
	
	private  static IAttachmentStore getIdentifiedAttachmentStore(String name){
		
		if (name.equalsIgnoreCase(SpagicConstants.ATTACHMENT_STORE_DB)){
			return new DBAttachmentStore();
		}else{
			return new FileSystemAttachmentStore();
		}
	}
}
