/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/* This file contains code modified from Apache code */
package org.spagic3.common.util;

import javax.xml.transform.Source;

import org.dom4j.Document;
import org.dom4j.DocumentHelper;
import org.dom4j.Namespace;
import org.dom4j.QName;
import org.dom4j.io.DocumentSource;

public class DOM4JUtils {
	public static  Source getDOM4JDocumentSource(org.spagic3.nmr.api.Message nm) throws Exception {
    	if (nm.getBody() instanceof Source) {
			return (Source)nm.getBody();	
		}
		if (nm.getBody() instanceof String) {
			return getDOM4JSourceFromStringBody((String)nm.getBody());
		}else{
			throw new Exception(" Cannot get Source from nm");
		}
    }
	
	private static Source getDOM4JSourceFromStringBody(String body) throws Exception {
		Document doc = DocumentHelper.parseText(body);
    	DocumentSource ds = new DocumentSource(doc);
    	return ds;
	}
	
	public static  QName toDOM4JQName(javax.xml.namespace.QName qName){
		
		QName dom4JQName = QName.get(qName.getLocalPart(), new Namespace(qName.getPrefix(), qName.getNamespaceURI()));
		return dom4JQName;
	}
}
