package org.spagic3.components.bpm.activator;

import org.osgi.framework.BundleActivator;
import org.osgi.framework.BundleContext;
import org.spagic.workflow.api.IProfileService;
import org.spagic3.components.bpm.IDatasourceManagerTracker;
import org.spagic3.components.bpm.invoker.IServiceInvoker;
import org.spagic3.components.bpm.invoker.InvokerServiceTracker;
import org.spagic3.components.bpm.profile.ProfileServiceTracker;
import org.spagic3.datasource.IDataSourceManager;

import bsh.BshClassManager;
import bsh.Interpreter;

public class BPMComponentActivator implements BundleActivator {

	
	private static InvokerServiceTracker invokerServiceTracker = null;
	private static IDatasourceManagerTracker iDatasourceManagerTracker = null;
	private static ProfileServiceTracker profileServiceTracker = null;
	
	private static BundleContext ctx = null;
	
	

	@Override
	public void start(BundleContext context) throws Exception {
		ctx = context;
		System.setProperty("SPAGIC_HIBERNATE_OSGI_STRATEGY", "org.spagic3.components.bpm.OSGiSessionFactoryInitializer");
		invokerServiceTracker = new InvokerServiceTracker(context);
		iDatasourceManagerTracker = new IDatasourceManagerTracker(context);
		profileServiceTracker = new ProfileServiceTracker(context);
		iDatasourceManagerTracker.open();
		invokerServiceTracker.open();
		profileServiceTracker.open();
	}

	@Override
	public void stop(BundleContext context) throws Exception {
		iDatasourceManagerTracker.close();
		invokerServiceTracker.close();
		profileServiceTracker.close();
	}
	
	
	public static IServiceInvoker getServiceInvoker(){
		return (IServiceInvoker)invokerServiceTracker.getService();
	}
	
	public static IDataSourceManager getDataSourceManager(){
		return (IDataSourceManager)iDatasourceManagerTracker.getService();
	}
	
	public static IProfileService getAuthorizationService(){
		return (IProfileService)profileServiceTracker.getService();
	}
	
	public static BundleContext getCtx() {
		return ctx;
	}
	
}
