package org.spagic3.components.bpm.deploy;

import org.eclipse.stp.im.StpIntermediateModel;

public interface IDeploymentProcessor {
	/**
	 * Change the Intermediate Model Process according to some specific binding
	 * rules.
	 * @param process Original IM process
	 * @param stpIntermediateModel
	 * @return Modified IM process
	 */
	public void process(StpIntermediateModel imModel);
	
	
	
	/**
	 * @return The binding managed by the processor, i.e. runtime.bpel or runtime.jbi.smx
	 */
	String getRuntimeId();
	
	/**
	 * @return The tecnology managed by the processor, i.e. JBI or BPEL
	 */
	String getTechnology();
	
	
	boolean handleAutomaticVersioning();
	
}
