package org.spagic3.components.bpm.monitoring;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.jbpm.logging.LoggingService;
import org.jbpm.logging.log.ProcessLog;
import org.spagic.monitoring.jbpm.MonitorServiceJBPM;
import org.spagic.monitoring.jbpm.message.JBPMMessage;


public class Spagic3MonitoringService implements LoggingService {

	private static final long serialVersionUID = 1L;
	private static final Logger log = LoggerFactory.getLogger(Spagic3MonitoringService.class);

	private MonitorServiceJBPM monitorService = null;
	
	public Spagic3MonitoringService() {
		super();
    	monitorService = new MonitorJBPMSpagic3();
	}

	public void log(ProcessLog processLog) {
		JBPMMessage jbpmMessage = new JBPMMessage(processLog, log);
		monitorService.traceMessage(jbpmMessage);
	}

	public void close() {
	}

}
