/**

    Copyright 2007, 2010 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package org.spagic3.components.empty;



import org.spagic3.core.BaseSpagicService;
import org.spagic3.core.ExchangeUtils;
import org.spagic3.nmr.api.Exchange;
import org.spagic3.nmr.api.Status;

public class EmptyOutComponent extends BaseSpagicService {

	public void process(Exchange exchange){
	  // Skip done exchanges
      if (exchange.getStatus() == Status.Done) {
          return;
      // Handle error exchanges
      } else if (exchange.getStatus() == Status.Error) {
          return;
      }
      if (ExchangeUtils.isInAndOut(exchange)) {
      		fail(exchange, new UnsupportedOperationException("Use an InOnly or RobustInOnly MEP"));
      } else {
          done(exchange);
      }
      
	}
    
	

}
