/**

    Copyright 2007, 2010 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package org.spagic3.components.jdbc.config;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.dom4j.Document;
import org.dom4j.Element;
import org.dom4j.Namespace;

public class XmlNamespaceUtils {
	
	
	public static Map<String,String> retrieveNameSpace(Document doc){
		List<Namespace> ns = new ArrayList<Namespace>();
		retrieveNamespace(doc.getRootElement(), ns);
		Map<String, String> namespaceMap = new HashMap<String, String>();
		for (Namespace n : ns){
			namespaceMap.put(n.getPrefix(), n.getURI());
		}
		return namespaceMap;
	}
	public static void retrieveNamespace(Element el, List l){
		l.addAll(el.declaredNamespaces());
		if (!isLeaf(el)){
			List<Element> childs = el.elements();
			for ( Element e : childs)
				retrieveNamespace(e, l);
		}
	}
	
	public static boolean isLeaf(Element elem){
		return elem.elements().size() == 0;
	}
}
