package org.spagic3.connectors.mail.custom.marshaller;

import javax.mail.internet.MimeMessage;

public class PECTransferObject {

	private String datiCert = null;
	private MimeMessage originalMessage = null;
	private int type = -1;
	private String typeAsString = null;
	
	public PECTransferObject(){
		datiCert = null;
		originalMessage = null;
	}
	public PECTransferObject(String datiCert, MimeMessage originalEmailMessage) {
		super();
		this.datiCert = datiCert;
		this.originalMessage = originalEmailMessage;
	}

	public String getDatiCert() {
		return datiCert;
	}

	public void setDatiCert(String datiCert) {
		this.datiCert = datiCert;
	}
	public MimeMessage getOriginalMessage() {
		return originalMessage;
	}
	public void setOriginalMessage(MimeMessage originalMessage) {
		this.originalMessage = originalMessage;
	}
	public int getType() {
		return type;
	}
	public void setType(int type) {
		this.type = type;
		
		switch (type) {
		case PECMimeMessage.ACCETTAZIONE:
			typeAsString = "ACCETTAZIONE";
			break;
		case PECMimeMessage.PRESA_IN_CARICO:
			typeAsString = "PRESA_IN_CARICO";
			break;
		case PECMimeMessage.AVVENUTA_CONSEGNA:
			typeAsString = "AVVENUTA_CONSEGNA";
			break;
		case PECMimeMessage.POSTA_CERTIFICATA:
			typeAsString = "POSTA_CERTIFICATA";
			break;
		case PECMimeMessage.ERRORE_CONSEGNA:
			typeAsString = "ERRORE_CONSEGNA";
			break;
		case PECMimeMessage.ANOMALIA:
			typeAsString = "ANOMALIA";
			break;
	
		default:
			typeAsString = "NESSUN_TIPO_SPECIFICATO";
		break;
		}
	}
	
	public String getTypeAsString() {
		return typeAsString;
	}
	
	public boolean isNotifica(){
		return ( type == PECMimeMessage.ACCETTAZIONE 
				|| type == PECMimeMessage.AVVENUTA_CONSEGNA 
				|| type == PECMimeMessage.PRESA_IN_CARICO 
				|| type == PECMimeMessage.ERRORE_CONSEGNA);
	}

	
	
}
