package org.spagic3.constants;

import java.net.URI;

public class SpagicConstants {
	public final static String CORRELATION_ID = "CORRELATION_ID";
	
	public final static String SPAGIC_LOCAL_ID_PROPERTY = "local.spagic.id";
	public final static String SPAGIC_ID_PROPERTY = "spagic.id";
	
	public final static String SPAGIC_SENDER = "SPAGIC_SENDER";
	public final static String SPAGIC_TARGET = "SPAGIC_TARGET";	
	public final static String SPAGIC_FACTORYNAME = "factory.name";	
	public final static String SPAGIC_TYPE = "SPAGIC_TYPE";
	
	public final static String EXCHANGE_ID = "EXCHANGE_ID";
	
	public final static String SPAGIC_GENERIC_TOPIC = "SPAGIC/MESSAGES";
	public final static String SPAGIC_BASE_TOPIC = "SPAGIC/MESSAGES/";

	public final static String IN_ONLY_MEP = "in-only";
	public final static String IN_OUT_MEP = "in-out";
	
	public final static String OUT_PROPERTY = "OUTP";
	public final static String IN_PROPERTY = "INP";
	public final static String OUT_ATTACHMENT = "OUTA";
	public final static String IN_ATTACHMENT = "INA";
	public final static String FAULT_PROPERTY = "FAULTP";
	public final static String EXCHANGE_PROPERTY = "EP";
	public final static String INBODY = "INBODY";
	public final static String OUTBODY = "OUTBODY";
	public final static String FAULTBODY = "FAULTBODY";
	public final static String EXCHANGE_MEP = "MEP";
	public final static String EXCHANGE_STATUS = "STATUS";
	public final static String EXCHANGE_ERROR = "ERROR";
	
	public final static String STATUS_ACTIVE = "ACTIVE";
	public final static String STATUS_DONE = "DONE";
	public final static String STATUS_ERROR = "ERROR";
	
	public final static String EXCHANGE_SENDER_NODE = "EXCHANGE_SENDER_NODE";
	public final static String EXCHANGE_TARGET_NODE = "EXCHANGE_TARGET_NODE";
	
	public static final String SERVICE_TYPE_UNDEFINED = "UNDEFINED";
	public static final String SERVICE_TYPE_CONNECTOR = "CONNECTOR";
	public static final String SERVICE_TYPE_SERVICE = "SERVICE";
		
	public static final String SOAP_FAULT_CODE = "spagic.soap.fault.code";
    public static final String SOAP_FAULT_SUBCODE = "spagic.soap.fault.subcode";
    public static final String SOAP_FAULT_REASON = "spagic.soap.fault.reason";
    public static final String SOAP_FAULT_NODE = "spagic.soap.fault.node";
    public static final String SOAP_FAULT_ROLE = "spagic.soap.fault.role";
    
    
    public static final URI IN_ONLY_URI = URI.create("http://www.w3.org/2004/08/wsdl/in-only");
    public static final URI IN_OUT_URI = URI.create("http://www.w3.org/2004/08/wsdl/in-out");
    public static final URI IN_OPTIONAL_OUT_URI = URI.create("http://www.w3.org/2004/08/wsdl/in-opt-out");
    public static final URI ROBUST_IN_ONLY_URI = URI.create("http://www.w3.org/2004/08/wsdl/robust-in-only");

    
    public static final String PROTOCOL_HEADERS = "nmr.messaging.protocol.headers";
    
    public static final String SPAGIC_HOME_PROPERTY="spagic.home";
	public static final String CONNECTORS_FOLDER="connectors";
	public static final String SERVICES_FOLDER="services";
	public static final String DATASOURCES_FOLDER="datasources";
	public static final String CONNECTIONFACTORIES_FOLDER="connectionfactories";
	public static final String RESOURCES_FOLDER="resources";
	public static final String ROUTES_FOLDER="routes";
	public static final String LOG_BACK_FILE_SYS_PROP = "logback.configurationFile";
	
	public static final String[] SERVICE_DEPLOYMENTS_EXTENSIONS = {"service","scrappy"};
	public static final String[] CONNECTOR_DEPLOYMENTS_EXTENSIONS = {"connector","service","scrappy"};
	public static final String[] DATASOURCE_DEPLOYMENTS_EXTENSIONS = {"datasource","ds","scrappy"};
	public static final String[] CONNECTIONFACTORY_DEPLOYMENTS_EXTENSIONS = {"connectionfactory","cf","scrappy"};
	public static final String[] ROUTES_DEPLOYMENTS_EXTENSIONS = {"route","doo"};
	
	
	
	
	//This variables could be setted into the exchange to modify wf engine behavour
    
    //
    // This will set/update the variable called VAR_A in Workflow Process Instance
    // exchange.setProperty("WF_VARIABLE.VAR_A", "ValueOfVariableA");
    //
    public final static String WF_VARIABLE_PREFIX = "WF_VARIABLE";
    
    //
    // This will say to OSGiService Invoker do not update the value of the XML_MESSAGE_VARIABLE_WHEN_RETURNING
    // from workflow
    // exchange.setProperty("WF_NO_UPDATE_XML_MESSAGE", "true");
    //
    public final static String WF_NO_UPDATE_XML_MESSAGE = "WF_NO_UPDATE_XML_MESSAGE";
   
    //
    //
    //
    // If this property id valorized when the Workflow Process Instance is end the result is not propagated to
    // the target connectors of orchestration service
    //
    //
    public final static String WF_IS_PROCESS_TERMINATED = "WF_IS_PROCESS_TERMINATED";

    //
	// The variable name for storing the process instance id
    //
	public static final String WF_PROCESS_INSTANCE_ID_VARIABLE = "PROCESS_INSTANCE_ID_VARIABLE".intern();

	public static final String SYNC_EXCHANGE = "SYNC_EXCHANGE";
	
	public static final String 	_IS_INTERNAL_EVENT = "_IS_INTERNAL_EVENT";
	
	public static final String 	_INTERNAL_EVENT_TYPE = "_INTERNAL_EVENT_TYPE";
	public static final String  _INTERNAL_EVENT_DS_DEPLOYED = "_INTERNAL_EVENT_DS_DEPLOYED";
	public static final String  _INTERNAL_EVENT_DS_UNDEPLOYED = "_INTERNAL_EVENT_DS_UNDEPLOYED";
	public static final String  _INTERNAL_EVENT_CF_DEPLOYED = "_INTERNAL_EVENT_CF_DEPLOYED";
	public static final String  _INTERNAL_EVENT_CF_UNDEPLOYED = "_INTERNAL_EVENT_CF_UNDEPLOYED";
	public static final String  _INTERNAL_EVENT_REFERRING_ID = "_INTERNAL_EVENT_REFERRING_ID";
	
	public static final String  _INTERNAL_EVENT_CONNECTOR_PAUSED = "_INTERNAL_EVENT_CONNECTOR_PAUSED";
	public static final String  _INTERNAL_EVENT_CONNECTOR_STARTED = "_INTERNAL_EVENT_CONNECTOR_STARTED";
	public static final String  _INTERNAL_EVENT_CONNECTOR_STOPPED = "_INTERNAL_EVENT_CONNECTOR_STOPPED";
	
	public static final String  _INTERNAL_EVENT_PROCESS_STARTED = "_INTERNAL_EVENT_PROCESS_STARTED";
	public static final String  _INTERNAL_EVENT_PROCESS_ID = "_INTERNAL_EVENT_PROCESS_ID";
	
	
	public static final String SPAGIC_MODE = "spagic.mode";
	public static final String SPAGIC_DEMO_MODE = "demo";
	public static final String SPAGIC_PRODUCTION_MODE = "production";
	
	
	public final static String SPAGIC_NODE_IDENTIFIER = "SPAGIC_NODE_IDENTIFIER";
	public final static String SPAGIC_NODE_TYPE = "SPAGIC_NODE_TYPE";
	public final static String EVENT_ADMIN_TYPE = "eaType";
	public final static String DISTRIBUTED_EVENT_ADMIN_TYPE = "distributed";
	public final static String DISTRIBUTED_EVENT_ADMIN_TOPIC_URL = "DISTRIBUTED_EVENT_ADMIN_TOPIC_URL";
	
	public final static String SPAGIC_NODE_TYPE_MASTER = "master";
	public final static String SPAGIC_NODE_TYPE_SLAVE = "slave";
	
	public final static String _IS_CLUSTER_ENABLED = "isClustered";
	public final static String _IS_MASTER_SLAVE_ENABLED = "isMasterSlave"; 
	public final static String _CLUSTER_ID = "clusterId";
	public final static String _SLAVE_MASTER = "masterId";
	
	public final static String ATTACHMENT_STORE_TYPE = "spagic.attachment.store";
	public final static String ATTACHMENT_STORE_FYLESYSTEM = "fs";
	public final static String ATTACHMENT_STORE_FYLESYSTEM_ROOT = "fs.root";
	public final static String ATTACHMENT_STORE_DB = "db";
	
	public final static String EXCHANGE_STORE = "spagic.exchange.store";
	public final static String EXCHANGE_STORE_OSGI_PREF = "osgi.pref";
	public final static String EXCHANGE_STORE_DB = "db";
	
	
	public final static String SPAGIC_ROUTER = "SPAGIC_ROUTER";
	
	
	
	
}
