/**

    Copyright 2007, 2010 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package org.spagic3.databaseManager.activator;

import org.osgi.framework.BundleActivator;
import org.osgi.framework.BundleContext;
import org.spagic3.databaseManager.datasource.IDatasourceManagerTracker;
import org.spagic3.datasource.IDataSourceManager;

public class DatabaseComponentActivator implements BundleActivator {

	
	private static IDatasourceManagerTracker iDatasourceManagerTracker = null;
	
	@Override
	public void start(BundleContext context) throws Exception {
		System.setProperty("SPAGIC_HIBERNATE_OSGI_STRATEGY", "org.spagic3.components.bpm.OSGiSessionFactoryInitializer");
		iDatasourceManagerTracker = new IDatasourceManagerTracker(context);
		iDatasourceManagerTracker.open();
	}

	@Override
	public void stop(BundleContext context) throws Exception {
		iDatasourceManagerTracker.close();
	}
		
	public static IDataSourceManager getDataSourceManager(){
		return (IDataSourceManager)iDatasourceManagerTracker.getService();
	}
	
}
