/**

    Copyright 2007, 2010 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package org.spagic3.deployer;

import java.util.Hashtable;
import java.util.List;

public interface IDeploymentService {
	
	public static final String SPAGIC_SERVICE = "SPAGIC_SERVICE";
	public static final String SPAGIC_CONNECTOR = "SPAGIC_CONNECTOR";
	public static final String SPAGIC_DATASOURCE = "SPAGIC_DATASOURCE";
	public static final String SPAGIC_CONNECTIONFACTORY = "SPAGIC_CONNECTIONFACTORY";
		
	public void deployService(String spagicId, String factoryName, Hashtable properties);
	public void undeployService(String spagicId);
	
	public void deployConnector(String spagicId, String factoryName, Hashtable properties);
	public void undeployConnector(String spagicId);
	
	public void deployDatasource(String dataSourceID, Hashtable properties);
	public void undeployDatasource(String dataSourceID);
	
	public void deployConnectionFactory(String connectionFactoryID, String factoryName, Hashtable properties);
	public void undeployConnectionFactory(String connectionFactoryID);
	
	public void deployRoutes(List<String> updateRoutes, List<String> oldRoutes);
	
	
	
}
