/**

    Copyright 2007, 2010 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package org.spagic3.dirwatcher;

import java.io.File;

public class DirFilterWatcher implements java.io.FileFilter {
	
	  private String[] filters;

	  public DirFilterWatcher() {
	    this.filters = new String[0];
	  }

	  public DirFilterWatcher(String filter) {
	    this(new String[]{filter});
	  }
	  
	  public DirFilterWatcher(String[] filters) {
		    this.filters = filters;
	  }
	  
	  public boolean accept(File file) {
		  if (filters.length == 0){
			  return true;
		  }else{
			  String fileName = file.getName().toLowerCase();
			  for ( int i =0; i < filters.length; i++){
	    		if (fileName.endsWith(filters[i]))
	    	        return true;
			  	}
			  return false;
		  }
	  }

}
