package org.spagic3.exchanges;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.spagic3.nmr.api.Exchange;

public class ExchangeSerializer {
	
	private static final Logger logger = LoggerFactory.getLogger(ExchangeSerializer.class); 
		
	public byte[] toByteArray(Exchange exchange){
		try{
			// Serialize to a byte array 
			ByteArrayOutputStream bos = new ByteArrayOutputStream(); 
			ObjectOutputStream out = new ObjectOutputStream(bos) ; 
			out.writeObject(exchange); 
			out.close(); 
		
			// Get the bytes of the serialized object 
			byte[] buf = bos.toByteArray();
			return buf;
		}catch (IOException e) {
			logger.error(e.getMessage(), e);
			return null;
		}
	}
	
	public Exchange fromByteArray(byte[] bytes){
		try{
			
			ObjectInputStream in = new ObjectInputStream(new ByteArrayInputStream(bytes)); 
			Exchange e = (Exchange)in.readObject(); 
			in.close(); 
			return e;
		}catch (Exception e) {
			logger.error(e.getMessage(), e);
			return null;
		}
	}
}
