package org.spagic3.exchanges;

import org.spagic3.nmr.api.Exchange;

/**
 * Interface <code>IExchangeStore</code> contract for the classes
 * providing persistence for the Exchange objects.
 *
 * @author <a href="mailto:saint@eng.it">Gian Uberto Lauri</a>
 * @version $Revision$
 */
public interface IExchangeStore {

	

	/**
	 * <code>store</code> persists an Exchange object
	 *
	 * @param pid a <code>Long</code> id of the Exchange object to be
	 * persisted
	 * @param ex an <code>Exchange</code> the Exchange object to be
	 * persisted
	 */
	public void store(Long pid, Exchange ex);

	/**
	 * <code>load</code> retrieves an Exchange object from its pid
	 *
	 * @param pid a <code>Long</code> id of the Exchange object to be
	 * retrieved
	 * @return an <code>Exchange</code> the Exchange object retrieved
	 */
	public Exchange load(Long pid);
	/**
	 * <code>delete</code> retrieves and deletes an Exchange object
	 * from its pid
	 *
	 * @param pid a <code>Long</code> id of the Exchange object to be
	 * retrieved and deleted to be persisted
	 * @return an <code>Exchange</code> the Exchange object retrieved
	 * and deleted to be persisted
	 */
	public Exchange delete(Long pid);

}
