package org.spagic3.exchanges;

import org.osgi.service.prefs.Preferences;
import org.osgi.service.prefs.PreferencesService;
import org.spagic3.nmr.api.Exchange;

public class OSGiPreferenceExchangeStore implements IExchangeStore {

	private  PreferencesService preferenceService = null;
	private static final String NODE_EXCHANGES = "exchanges";
	private ExchangeSerializer serializer = new ExchangeSerializer();
	
		
	

	public PreferencesService getPreferenceService() {
		return preferenceService;
	}

	public void bindPreferenceService(PreferencesService preferenceService) {
		this.preferenceService = preferenceService;
	}
	
	public void unbind(PreferencesService preferenceService) {
		this.preferenceService = preferenceService;
	}

	@Override
	public Exchange delete(Long pid) {
		Preferences pref = getPreferenceService().getSystemPreferences().node(NODE_EXCHANGES);
		Exchange e = load(pid);
		pref.remove(pid.toString());
		return e;
	}

	

	@Override
	public Exchange load(Long pid) {
		Preferences pref = getPreferenceService().getSystemPreferences().node(NODE_EXCHANGES);
		byte[] bytes = pref.getByteArray(pid.toString(), null);
		if (bytes != null){
			return (Exchange)serializer.fromByteArray(bytes);
		}else{
			return null;
		}
	}

	@Override
	public void store(Long pid, Exchange ex) {
		Preferences pref = getPreferenceService().getSystemPreferences().node(NODE_EXCHANGES);
		byte[] bytes = serializer.toByteArray(ex);
		if (bytes != null){
			pref.putByteArray(pid.toString(), bytes);
		}else{
			return;
		}
		
	}
	
}
