package org.spagic3.jmsconnectionfactory.activemq;

import javax.jms.JMSException;

import org.jencks.amqpool.PooledConnectionFactory;
import org.osgi.service.component.ComponentContext;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.spagic3.util.properties.PropertyConfigurator;

public class ConnectionFactory implements javax.jms.ConnectionFactory {
	
	private Logger logger = LoggerFactory.getLogger(ConnectionFactory.class);
	private PooledConnectionFactory pcf = null;
	
	@Override
	public javax.jms.Connection createConnection() throws JMSException {
		logger.debug("Creating connection");
		return pcf.createConnection();
	}

	@Override
	public javax.jms.Connection createConnection(String userName, String password)
			throws JMSException {
		logger.debug("Creating connection");
		return pcf.createConnection(userName, password);
	}

	protected void activate(ComponentContext componentContext){
		try{
			PropertyConfigurator propertyConfigurator = new PropertyConfigurator(componentContext.getProperties());
			String brokerURL = propertyConfigurator.getString("brokerURL");
			this.pcf = new PooledConnectionFactory(brokerURL);
		}catch (Exception e) {
			throw new IllegalStateException("Cannot istantiate ConnectionFactory", e);
		}
	}
		
}
