/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/* This file contains code modified from Apache code */
package org.spagic3.soap.interceptors.xml;

import javax.xml.stream.XMLStreamException;
import javax.xml.stream.XMLStreamReader;
import javax.xml.stream.XMLStreamWriter;
import javax.xml.transform.Source;

import org.spagic3.soap.api.Fault;
import org.spagic3.soap.api.Message;
import org.spagic3.soap.core.AbstractInterceptor;
import org.spagic3.soap.util.stax.StaxUtil;

/**

 */
public class BodyOutInterceptor extends AbstractInterceptor {

    public void handleMessage(Message message) {
        Source source = message.getContent(Source.class);
        XMLStreamWriter writer = message.getContent(XMLStreamWriter.class);
        XMLStreamReader reader = StaxUtil.createReader(source);
        try {
            StaxUtil.copy(reader, writer);
        } catch (XMLStreamException e) {
            throw new Fault(e);
        }
    }

}
